<template>
  <div>
    <back></back>
    <h1 class="i3-page-title">{{ 'New ' + (getFieldConfig([keys(nodesList)[0]]).label || 'Node') }}</h1>
    <div id="shortcut-area" v-if="showActiveZone">
      <h2>{{ activeTitle }}</h2>
      <div v-for="(activeField, index) in activeFields" :key="index">
        <!-- <pre>LOOO</pre>
        <pre>{{ activeField }}</pre>
        <pre>{{ getEditedNodes([activeField.type, activeField.key]) }}</pre> -->
        <items-types-form :node="getEditedNodes([activeField.type, activeField.key]) || {}" :path="activeField.path"></items-types-form>
        <!-- <item-form :label="(getFieldConfig(activeField) || {}).label + (Number.isInteger(activeField.path.slice(-1).pop()) ? ' #' + (activeField.path.slice(-1).pop() + 1) : '')" :node="activeField.node" :path="activeField.path" :config="getFieldConfig(activeField)" :index="Number.isInteger(activeField.path.slice(-1).pop()) ? activeField.path.slice(-1).pop() : -1"></item-form> -->
      </div>
    </div>

    <div v-for="(nodes, type) in nodesList" :key="type">
      <div v-for="(node, key) in nodes" :key="key">
        <button @click="addNode(node)">Save</button>
        {{ nodesList }}
        <items-form :title="'New ' + (getFieldConfig([type]).label || 'Node')" :node="getEditedNodes([type, key])" :path="[]" :config="getFieldConfig([type])"></items-form>
      </div>
    </div>
<!--
    <button @click="addNode(currentNode)">Save</button>
    {{ currentNode }}
    <items-form :title="'New ' + getFieldConfig([contentType, 'label'])" :node="currentNode" :path="[]" :config="getFieldConfig([contentType])"></items-form> -->
  </div>
</template>

<script>
import _ from 'lodash'

// import { EDITABLE_GHOST_ZONES } from '@/components/Editable/config'
import ItemsForm from '@/components/Editable/Sidebar/EditorCategory/ItemsForm'
import ItemsTypesForm from '@/components/Editable/Sidebar/EditorCategory/ItemsTypesForm'
import Back from '@/components/Editable/Utils/Back'
import { mapActions, mapGetters } from 'vuex'

export default {
  components: {
    ItemsForm,
    ItemsTypesForm,
    Back
  },

  props: {
    // contentType: {
    //   type: String,
    //   required: true
    // }
    // timestamp: {
    //   type: Number,
    //   required: true
    // }
  },

  data () {
    return {
      // nid: 'new-' + this.timestamp
    }
  },

  computed: {
    ...mapGetters({
      showActiveZone: 'Y3TI/showActiveZone',
      activeFields: 'Y3TI/activeFields',
      activeTitle: 'Y3TI/activeTitle',

      getEditableNodes: 'Y3TI/getEditableNodes',
      getFieldConfig: 'Y3TI/getFieldConfig',
      getEditedNodes: 'Y3TI/getEditedNodes',
      backPageTitle: 'Y3TI/backPageTitle'
      // contentTypes: 'Y3TI/contentTypes'
    }),
    // node () {
    //   return {
    //     _new: true,
    //     _type: this.contentType,
    //     nid: this.nid
    //   }
    // },
    nodesList () {
      return this.getEditableNodes(this.$route.path)
    }
    // currentNode () {
    //   return this.getEditedNodes([this.contentType, 'nid-' + this.nid])
    // }
  },

  methods: {
    ...mapActions({
      saveEditedNodeData: 'Y3TI/saveEditedNodeData',
      // pushSidebarPage: 'Y3TI/pushSidebarPage',
      backSidebarPage: 'Y3TI/backSidebarPage',
      setOriginalNodesDisplay: 'Y3TI/setOriginalNodesDisplay',
      unsetEditableActiveZone: 'Y3TI/unsetEditableActiveZone'
      // setEditableNodeCall: 'Y3TI/setEditableNode',
      // setEditableActiveZone: 'Y3TI/setEditableActiveZone'

      // getContentTypes: 'Y3TI/getContentTypes'
    }),
    // async setEditableNode (node, related) {
    //   await this.setEditableNodeCall({ data: { path: this.$route.path, node, related } }).catch((err) => {
    //     console.log(err)
    //   })
    // },

    // pushPage (component, props, title) {
    //   return this.pushSidebarPage({ data: { page: { component, props, title } } })
    // },

    backPage () {
      this.unsetEditableActiveZone({ data: { id: '*' } })
      this.setOriginalNodesDisplay(false)
      this.backSidebarPage()
    },

    addNode (node) {
      console.log('node', node)
      this.saveEditedNodeData({ data: { action: 'addNode', node } })
    },

    keys: _.keys
    // handleGhostZone (ghostZone) {
    //   if (!ghostZone) {
    //     const ghostZones = EDITABLE_GHOST_ZONES(this.currentNode)
    //     if (ghostZones) {
    //       ghostZone = ghostZones[this.contentType]
    //     }
    //   }

    //   if (ghostZone) {
    //     this.setEditableActiveZone({ data: { isDefault: true, ...ghostZone } })
    //   }
    // }
    // nextComponent (key) {
    //   return _.isEmpty(EDITABLE_NODE_PRESETS[key]) ? 'new-node-form-category' : 'new-node-presets-category'
    // }
  },

  created () {
    // this.setEditableNode(this.node)
    // this.handleGhostZone()
    // this.$router.push({ name: 'NewNode', params: { contentType: this.contentType } })

    // this.getContentTypes({ options: { lazy: true } })
  }
}
</script>
